(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
// Calling define with a dependency array and a factory function
define([], function() {
    // Define the module value by returning a value.
    return {
        api: require('./src/api'),
        charts: require('./src/charts'),
        util: require('./src/util')
    };
});

},{"./src/api":2,"./src/charts":3,"./src/util":17}],2:[function(require,module,exports){
(function (process){
const NO_DATA_MSG = 'N/A';

const ENA_VIEW_URL = 'https://www.ebi.ac.uk/ena/data/view/';
const EUROPE_PMC_ENTRY_URL = 'https://europepmc.org/abstract/MED/';
const DX_DOI_URL = 'http://dx.doi.org/';
const EBI_BIOSAMPLE_URL = 'https://www.ebi.ac.uk/biosamples/';

// Based off of CommonJS / AMD compatible template:
// https://github.com/umdjs/umd/blob/master/templates/commonjsAdapter.js

(function(root, factory) {
    if (typeof define === 'function' && define.amd) {
        // AMD. Register as an anonymous module.
        define(['backbone', 'underscore', './util'], factory);
        // } else {
        // Browser globals
        // root.amdWeb = factory(root.b);
    }
}(typeof self !== 'undefined' ? self : this, function(Backbone, underscore, util) {
    const _ = underscore;

    let init = function(options) {
        // Prioritize env variables over options
        const API_URL = (typeof process !== 'undefined') ? process.env.API_URL : options['API_URL'];
        const subfolder = (typeof process !== 'undefined')
            ? process.env.DEPLOYMENT_SUBFOLDER
            : options['SUBFOLDER'];

        // Model for an individual study
        const Study = Backbone.Model.extend({
            url() {
                return API_URL + 'studies/' + this.id;
            },
            parse(d) {
                const data = d.data !== undefined ? d.data : d;
                const attr = data.attributes;
                const biomes = util.simplifyBiomeIcons(
                    data.relationships.biomes.data.map(util.getBiomeIconData));
                let relatedStudies = [];
                if (data.relationships.hasOwnProperty('studies')) {
                    data.relationships.studies.data.forEach((study) => {
                        study.study_url = subfolder + '/studies/' + study.id;
                        relatedStudies.push(study);
                    });
                    // for (let i in relatedStudies) {
                    //     relatedStudies[i].study_url = subfolder + '/studies/' +
                    //         relatedStudies[i].id;
                    // }
                }
                return {
                    // Processed fields
                    biomes: biomes,
                    study_url: subfolder + '/studies/' + attr['accession'],
                    samples_url: subfolder + '/studies/' + attr['accession'] +
                    '#samples-section',
                    ena_url: ENA_VIEW_URL + attr['secondary-accession'],
                    related_studies: relatedStudies,

                    // Standard fields
                    bioproject: attr['bioproject'],
                    samples_count: attr['samples-count'],
                    study_accession: attr['accession'],
                    study_secondary_accession: attr['secondary-accession'],
                    centre_name: attr['centre-name'],
                    public_release_date: attr['public-release-date'],
                    abstract: attr['study-abstract'],
                    study_name: attr['study-name'],
                    data_origination: attr['data-origination'],
                    last_update: util.formatDate(attr['last-update'])
                };
            }
        });

        const StudiesCollection = Backbone.Collection.extend({
            url: API_URL + 'studies',
            model: Study,
            parse(response) {
                return response.data;
            }
        });

        const SampleStudiesCollection = Backbone.Collection.extend({
            model: Study,
            initialize(params) {
                this.url = API_URL + 'samples/' + params['sample_accession'] + '/studies';
            },
            parse(response) {
                return response.data;
            }
        });

        const Run = Backbone.Model.extend({
            url() {
                return API_URL + 'runs/' + this.id;
            },
            parse(d) {
                // Adaption to handle 'includes' on API calls which would wrap the response
                const data = d.data !== undefined ? d.data : d;
                const attr = data.attributes;
                const rel = data.relationships;
                const pipelines = rel.pipelines;
                const sampleId = rel.sample.data.id;
                const studyId = rel.study.data.id;
                return {
                    // Processed fields
                    ena_url: ENA_VIEW_URL + attr['accession'],
                    sample_accession: sampleId,
                    sample_url: subfolder + '/samples/' + sampleId,
                    analysis_url: subfolder + '/runs/' + attr.accession,
                    pipeline_versions: pipelines.data.map(function(x) {
                        return x.id;
                    }),
                    analysis_results: 'TAXONOMIC / FUNCTION / DOWNLOAD',
                    study_accession: studyId,
                    study_url: subfolder + '/studies/' + studyId,

                    // Standard fields
                    experiment_type: attr['experiment-type'],
                    run_accession: attr['accession'],
                    secondary_run_accession: attr['secondary-accession'],
                    instrument_model: attr['instrument-model'],
                    instrument_platform: attr['instrument-platform']
                };
            }
        });

        /**
         * Generate Krona URL
         * @param {string} analysisID ENA Run primary accession
         * @param {string} ssuOrLsu subunit type (for pipeline version 4.0 and above)
         * @return {string} url
         */
        function getKronaURL(analysisID, ssuOrLsu) {
            return API_URL + 'analyses/' + analysisID + '/krona' + ssuOrLsu + '?collapse=false';
        }

        const RunsCollection = Backbone.Collection.extend({
            url: API_URL + 'runs',
            model: Run,
            initialize(params) {
                // Project/sample ID
                if (typeof(params) !== 'undefined') {
                    if (params.hasOwnProperty(('study_accession'))) {
                        this.study_accession = params.study_accession;
                    }
                    // Sample ID
                    if (params.hasOwnProperty(('sample_accession'))) {
                        this.sample_accession = params.sample_accession;
                    }
                    this.params = params;
                }
            },
            parse(response) {
                return response.data;
            }
        });

        const Biome = Backbone.Model.extend({
            url() {
                return API_URL + 'biomes/' + this.id;
            },
            parse(data) {
                // Work-around when requesting root biome
                if (data.data) {
                    data = data.data;
                }
                const attr = data.attributes;
                const lineage = attr['lineage'];
                return {
                    name: util.lineageToBiome(lineage),
                    icon: util.getBiomeIcon(lineage),
                    lineage: lineage,
                    samples_count: attr['samples-count'],
                    biome_studies_url: subfolder + '/browse?lineage=' + lineage + '#studies'
                };
            }
        });

        const BiomeCollection = Backbone.Collection.extend({
            model: Biome,
            url: API_URL + 'biomes',
            parse(response) {
                return response.data;
            }
        });

        const BiomeWithChildren = Backbone.Collection.extend({
            model: Biome,
            url() {
                return API_URL + 'biomes/' + this.rootLineage + '/children';
            },
            initialize(data) {
                if (data.hasOwnProperty('rootLineage')) {
                    this.rootLineage = data['rootLineage'];
                } else {
                    this.rootLineage = 'root';
                }
            },
            parse(response) {
                return response.data;
            }
        });

        const Sample = Backbone.Model.extend({
            url() {
                return API_URL + 'samples/' + this.id;
            },
            parse(d) {
                const data = d.data !== undefined ? d.data : d;
                const attr = data.attributes;

                let metadatas = _.map(attr['sample-metadata'], function(el) {
                    const key = el.key;
                    return {
                        name: key[0].toUpperCase() + key.slice(1),
                        value: el.value,
                        unit: el.unit
                    };
                });

                // Adaption to handle 'includes' on API calls which would wrap the response
                const biome = util.getBiomeIconData(data.relationships.biome.data);
                const biomeName = data.relationships.biome.data.id;
                return {
                    biosample: attr['biosample'],
                    biosample_url: EBI_BIOSAMPLE_URL + 'samples/' + attr['biosample'],
                    biome: biome,
                    biome_icon: util.getBiomeIcon(biomeName),
                    biome_name: util.formatLineage(biomeName, true),
                    sample_name: attr['sample-name'] || NO_DATA_MSG,
                    sample_desc: attr['sample-desc'],
                    sample_url: subfolder + '/samples/' + attr['accession'],
                    ena_url: ENA_VIEW_URL + attr['accession'],
                    sample_accession: attr['accession'] || NO_DATA_MSG,
                    lineage: util.formatLineage(data.relationships.biome.data.id || NO_DATA_MSG,
                        true),
                    metadatas: metadatas,
                    runs: d.included,
                    last_update: util.formatDate(attr['last-update']),
                    latitude: attr.latitude,
                    longitude: attr.longitude
                };
            }
        });

        const SamplesCollection = Backbone.Collection.extend({
            url: API_URL + 'samples',
            model: Sample,
            initialize(data) {
                this.params = data || {};
            },
            parse(response) {
                return response.data;
            }
        });

        const Analysis = Backbone.Model.extend({
            url() {
                return API_URL + 'analyses/' + this.id;
            },
            parse(d) {
                const data = d.data !== undefined ? d.data : d;
                const attr = data.attributes;
                let studyID = data.relationships.study.data.id;
                let sampleID = data.relationships.sample.data.id;
                let runID = data.relationships.run.data.id;
                attr['analysis-summary'] = _.reduce(attr['analysis-summary'], function(obj, e) {
                    obj[e['key']] = e['value'];
                    return obj;
                }, {});
                return {
                    study_accession: studyID,
                    study_url: subfolder + '/studies/' + studyID,
                    sample_accession: sampleID,
                    sample_url: subfolder + '/samples/' + sampleID,
                    run_accession: runID,
                    run_url: subfolder +
                    (attr['experiment-type'] === 'assembly' ? '/assemblies/' : '/runs/') + runID,
                    analysis_accession: data['id'],
                    analysis_url: subfolder + '/analyses/' + data['id'],
                    experiment_type: attr['experiment-type'],
                    analysis_summary: attr['analysis-summary'],
                    complete_time: attr['complete-time'],
                    instrument_model: attr['instrument-model'],
                    instrument_platform: attr['instrument-platform'],
                    pipeline_version: attr['pipeline-version'],
                    pipeline_url: subfolder + '/pipelines/' + attr['pipeline-version'],
                    download: attr['download']
                };
            }
        });

        const RunAnalyses = Backbone.Collection.extend({
            initialize(data) {
                this.id = data.id;
            },
            url() {
                return API_URL + 'runs/' + this.id + '/analyses';
            },
            parse(d) {
                const data = d.data !== undefined ? d.data : d;
                let analyses = _.map(data, (analysis) => {
                    return Analysis.prototype.parse(analysis);
                });
                analyses = _.filter(analyses, (analysis) => {
                    return analysis['experiment_type'] !== 'assembly';
                });
                return analyses;
            }
        });

        const RunAssemblies = Backbone.Collection.extend({
            initialize(data) {
                this.id = data.id;
            },
            url() {
                return API_URL + 'runs/' + this.id + '/analyses';
            },
            parse(d) {
                const data = d.data !== undefined ? d.data : d;
                let analyses = _.map(data, (analysis) => {
                    return Analysis.prototype.parse(analysis);
                });
                analyses = _.filter(analyses, (analysis) => {
                    return analysis['experiment_type'] === 'assembly';
                });
                return analyses;
            }
        });

        /**
         * Reformat included samples in response
         * @param {object} response
         * @return {[object]}
         */
        function collectSamples(response) {
            let samples;
            if (response.hasOwnProperty('included')) {
                samples = response.included.reduce(function(obj, x) {
                    obj[x.id] = Sample.prototype.parse(x);
                    return obj;
                }, {});
            } else {
                samples = [];
            }
            return samples;
        }

// Retrieve analyses of a study
        const StudyAnalyses = Backbone.Collection.extend({
            initialize(data) {
                this.id = data.id;
                this.assemblies = data.assemblies; // Set to only || exclude || null
            },
            url() {
                return API_URL + 'studies/' + this.id + '/analyses';
            },
            parse(response) {
                let analyses = response.data;
                let samples = collectSamples(response);

                analyses = _.map(analyses, (analysis) => {
                    const sample = samples[analysis.relationships.sample.data.id];
                    analysis = Analysis.prototype.parse(analysis);
                    analysis['biome'] = sample['biome'];
                    analysis['sample_desc'] = sample['sample_desc'];
                    return analysis;
                });
                if (this.assemblies === 'exclude') {
                    analyses = _.filter(analyses, (analysis) => {
                        return analysis['experiment_type'] !== 'assembly';
                    });
                }
                return analyses;
            }
        });

        /**
         * Raw jQuery method used when complete set of paginated data is required
         * @param {object} that context for url fetching
         * @return {Promise}
         */
        function multiPageFetch(that) {
            const deferred = $.Deferred();
            let data = [];
            $.get({
                url: that.url(),
                success(response) {
                    try {
                        data = data.concat(response.data);
                        const numPages = response.meta.pagination.pages;
                        if (numPages > 1) {
                            let requests = [];
                            for (let x = 2; x <= numPages; x++) {
                                requests.push($.get(that.url() + '?page=' + x));
                            }
                            $.when(...requests).done(function() {
                                _.each(requests, function(response) {
                                    if (response.hasOwnProperty('responseJSON') &&
                                        response.responseJSON.hasOwnProperty('data')) {
                                        data = data.concat(response.responseJSON.data);
                                    }
                                });
                                deferred.resolve(data);
                            });
                        } else {
                            deferred.resolve(data);
                        }
                    } catch (exception) {
                        deferred.reject();
                    }
                }
            });
            return deferred.promise();
        }

        // Abstract class
        const GenericAnalysisResult = Backbone.Model.extend({
            initialize(params) {
                this.id = params.id;
                this.version = params.version;
                if (params.hasOwnProperty('type')) {
                    this.type = params.type;
                }
            }
        });

        const Taxonomy = GenericAnalysisResult.extend({
            url() {
                return API_URL + 'analyses/' + this.id + '/taxonomy' + this.type;
            },
            fetch() {
                return multiPageFetch(this);
            }
        });

        const InterproIden = GenericAnalysisResult.extend({
            url() {
                return API_URL + 'analyses/' + this.id + '/interpro-identifiers';
            },
            fetch() {
                return multiPageFetch(this);
            }
        });

        const GoSlim = GenericAnalysisResult.extend({
            url() {
                return API_URL + 'analyses/' + this.id + '/go-slim';
            }
        });

        /**
         * Cluster study download results by type and parts
         * @param {[object]} downloads
         * @return {[object]} grouped downloads
         */
        function clusterStudyDownloads(downloads) {
            const pipelines = {};
            _.each(downloads, function(download) {
                const attr = download.attributes;
                const group = attr['group-type'];
                const pipeline = download.relationships.pipeline.data.id;

                attr['link'] = download.links.self;
                if (!pipelines.hasOwnProperty(pipeline)) {
                    pipelines[pipeline] = {};
                }
                if (!pipelines[pipeline].hasOwnProperty(group)) {
                    pipelines[pipeline][group] = [];
                }

                pipelines[pipeline][group] = pipelines[pipeline][group].concat(download);
            });

            return pipelines;
        }

        let collator = new Intl.Collator(undefined, {numeric: true, sensitivity: 'base'});

        /**
         * Cluster run download results by type and parts
         * @param {[object]} downloads
         * @return {[object]} grouped downloads
         */
        function clusterAnalysisDownloads(downloads) {
            const groups = {};
            _.each(downloads, function(download) {
                const attr = download.attributes;
                const group = attr['group-type'];
                const label = attr.description.label;
                const format = attr['file-format']['name'];
                attr['links'] = [download.links.self];

                if (!groups.hasOwnProperty(group)) {
                    groups[group] = [];
                }
                if (attr['file-format']['compression']) {
                    attr['file-format']['compExtension'] = attr.alias.split('.')
                        .slice(-1)[0];
                }
                let grouped = false;
                _.each(groups[group], function(d) {
                    const groupLabel = d.attributes.description.label;
                    const groupFormat = d.attributes['file-format']['name'];
                    if (groupLabel === label && groupFormat === format) {
                        d.attributes.links = d.attributes.links.concat(download.links.self);
                        grouped = true;
                    }
                });
                if (!grouped) {
                    groups[group] = groups[group].concat(download);
                }
            });
            _.each(groups, function(group) {
                _.each(group, function(entry) {
                    entry.attributes.links.sort(collator.compare);
                });
            });

            return groups;
        }

        const StudyDownloads = Backbone.Model.extend({
            url() {
                return API_URL + 'studies/' + this.id + '/downloads';
            },
            parse(response) {
                this.attributes.pipelineFiles = clusterStudyDownloads(response.data);
            }
        });

        const AnalysisDownloads = Backbone.Model.extend({
            url() {
                return API_URL + 'analyses/' + this.id + '/downloads';
            },
            parse(response) {
                this.attributes.downloadGroups = clusterAnalysisDownloads(response.data);
            }
        });

        const StudyGeoCoordinates = Backbone.Model.extend({
            url() {
                return API_URL + 'studies/' + this.id +
                    '/geocoordinates?page_size=500';
            }
        });

        const QcChartData = Backbone.Model.extend({
            initialize(data) {
                this.id = data.id;
                this.type = data.type;
            },
            url() {
                return API_URL + 'analyses/' + this.id + '/' + this.type;
            }
        });

        const QcChartStats = QcChartData.extend({
            initialize(data) {
                this.id = data.id;
                this.type = 'summary';
            },
            parse(data) {
                const rows = data.split('\n');
                let vals = {};
                _.each(rows, function(row) {
                    let keyVal = row.split('\t');
                    vals[keyVal[0]] = parseFloat(keyVal[1]);
                });
                return vals;
            }
        });

        const Publication = Backbone.Model.extend({
            url() {
                return API_URL + 'publications/' + this.id;
            },
            parse(d) {
                const data = d.data !== undefined ? d.data : d;
                const attr = data.attributes;
                let authors = attr['authors'];
                if (authors.length > 50) {
                    authors = authors.split(',').slice(0, 5);
                    authors.push(' et al.');
                    authors = authors.join(',');
                }
                return {
                    pubmedID: attr['pubmed-id'],
                    pubmedCentralID: attr['pubmed-central-id'],
                    title: attr['pub-title'],
                    abstract: attr['abstract'],
                    authors: authors,
                    doi: attr['doi'],
                    isbn: attr['isbn'],
                    publishedYear: attr['published-year'],
                    issue: attr['issue'],
                    volume: attr['volume'],
                    rawPages: attr['raw-pages'],
                    isoJournal: attr['iso-journal'],
                    medicineJournal: attr['medicine-journal'],
                    pubURLsrc: attr['pub-url'],
                    pmc_url: EUROPE_PMC_ENTRY_URL + attr['pubmed-id'],
                    doi_url: DX_DOI_URL + attr['doi'],
                    pubMgnifyURL: subfolder + '/publications/' + attr['pubmed-id'],
                    studiesCount: attr['studies-count'],
                    samplesCount: attr['samples-count']
                };
            }
        });
        const PublicationsCollection = Backbone.Collection.extend({
            model: Publication,
            url: API_URL + 'publications',
            initialize(data) {
                this.params = data || {};
            },
            parse(response) {
                return response.data;
            }
        });

        const PublicationStudies = Backbone.Collection.extend({
            url() {
                return API_URL + 'publications/' + this.id + '/studies';
            },
            model: Study,
            initialize(data) {
                this.id = data['id'];
            },
            parse(response) {
                return response.data;
            }
        });

        return {
            API_URL,
            Study,
            StudiesCollection,
            SampleStudiesCollection,
            Run,
            RunsCollection,
            Biome,
            BiomeCollection,
            BiomeWithChildren,
            Sample,
            SamplesCollection,
            GenericAnalysisResult,
            getKronaURL,
            Analysis,
            RunAnalyses,
            RunAssemblies,
            StudyAnalyses,
            Taxonomy,
            InterproIden,
            GoSlim,
            StudyDownloads,
            AnalysisDownloads,
            StudyGeoCoordinates,
            QcChartData,
            QcChartStats,
            Publication,
            PublicationsCollection,
            PublicationStudies
        };
    };
    return init;
}));

}).call(this,require('_process'))
},{"_process":18}],3:[function(require,module,exports){
define([], function() {
    // Define the module value by returning a value.
    return {
        QcChart: require('./charts/qcChart'),
        TaxonomyPie: require('./charts/taxonomyPie'),
        TaxonomyColumn: require('./charts/taxonomyColumn'),
        TaxonomyColumnStacked: require('./charts/taxonomyColumnStacked'),
        NucleotideHist: require('./charts/nucleotideHist'),
        SeqFeatSumChart: require('./charts/seqFeatSumChart'),
        GcContentChart: require('./charts/gcContentChart'),
        GcDistributionChart: require('./charts/gcDistributionChart'),
        ReadsLengthHist: require('./charts/readsLengthHist'),
        SeqLengthChart: require('./charts/seqLengthChart'),
        InterproMatchPie: require('./charts/interproMatchPie'),
        GoTermBarChart: require('./charts/goTermBarChart'),
        GoTermPieChart: require('./charts/goTermPieChart')
    };
});

},{"./charts/gcContentChart":4,"./charts/gcDistributionChart":5,"./charts/goTermBarChart":6,"./charts/goTermPieChart":7,"./charts/interproMatchPie":8,"./charts/nucleotideHist":9,"./charts/qcChart":10,"./charts/readsLengthHist":11,"./charts/seqFeatSumChart":12,"./charts/seqLengthChart":13,"./charts/taxonomyColumn":14,"./charts/taxonomyColumnStacked":15,"./charts/taxonomyPie":16}],4:[function(require,module,exports){
define([
    './genericChart', '../util', 'highcharts', 'highcharts/modules/exporting'
], function(GenericChart, util, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Container for GcDistributionChart
     */
    class GcContentChart extends GenericChart {
        /**
         * Constructor for GcDistributionChart; provide accession OR this.data to generate chart.
         * @param {string} containerId id (without #) of container
         * @param {object} options to configure chart this.data source
         * (this.data or fetch parameters)
         */
        constructor(containerId, options) {
            super(containerId, options);
            this.loaded = $.Deferred();
            this.dataReady.done(() => {
                this.data = util.tsv2dict(this.data);
                // TODO fix once API no longer returns HTML error pages
                if (!this.data.hasOwnProperty('average_gc_content')) {
                    this.loaded.reject();
                    return;
                }
                const that = this;
                const options = {
                    chart: {
                        type: 'bar',
                        marginTop: 0, // Keep all charts left aligned
                        height: 150
                    },
                    title: false,
                    xAxis: {
                        categories: ['Content'],
                        title: {enabled: false},
                        lineColor: '#595959',
                        tickColor: ''
                    },
                    yAxis: {
                        min: 0,
                        max: 100,
                        title: {enabled: false},
                        plotBands: [
                            { // visualize the standard deviation
                                from: this.data['average_gc_content'] -
                                this.data['standard_deviation_gc_content'],
                                to: this.data['average_gc_content'] +
                                this.data['standard_deviation_gc_content'],
                                color: 'rgba(128, 128, 128, .2)'
                            }]
                    },
                    plotOptions: {
                        series: {
                            grouping: false,
                            shadow: false,
                            borderWidth: 0
                        }
                    },
                    series: [
                        {
                            name: 'GC content',
                            pointPadding: 0.25,
                            color: 'rgb(63, 114, 191)',
                            tooltip: {
                                pointFormatter: function() {
                                    return '<span style="color:' + this.color + '">\u25CF</span> ' +
                                        this.series.name + ': <b>' + (this.y).toFixed(2) +
                                        '%</b><br/>';
                                }
                            },
                            data: [this.data['average_gc_content']]
                        }, {
                            name: 'AT content',
                            color: 'rgb(114, 63, 191)',
                            pointPadding: 0.25,
                            threshold: this.data['average_gc_content'],
                            tooltip: {
                                pointFormatter: function() {
                                    const val = (100 - that.data['average_gc_content']).toFixed(2);
                                    return '<span style="color:' + this.color + '">\u25CF</span> ' +
                                        this.series.name + ': <b>' + val + '%</b><br/>';
                                }
                            },
                            data: [100]
                        }
                    ],
                    credits: false,
                    navigation: {
                        buttonOptions: {
                            height: 32,
                            width: 32,
                            symbolX: 16,
                            symbolY: 16,
                            y: -10
                        }
                    },
                    exporting: {enabled: false}
                };
                this.chart = Highcharts.chart(containerId, options);
                this.loaded.resolve();
            }).fail(() => {
                this.loaded.reject();
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch this.data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const seqLength = new this.api.QcChartData(
                {id: params['accession'], type: 'summary'});

            return $.when(seqLength.fetch({dataType: 'text'})).then((data) => {
                if (data[0] === '\n') {
                    return Promise.reject();
                }
                this.data = data;
            });
        }
    }

    return GcContentChart;
});

},{}],5:[function(require,module,exports){
define([
    './genericChart', '../util', 'highcharts', 'highcharts/modules/exporting'
], function(GenericChart, util, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Convert data from string to 2d array
     * @param {string} rawdata
     * @return {[[number, number]]}
     */
    function transformSeries(rawdata) {
        return rawdata.split('\n').map(function(line) {
            if (line.trim() !== '') {
                return line.split('\t').map(function(v) {
                    return 1 * v;
                });
            }
        }).reduce(
            function(acc, v) {
                if (v) {
                    let key = Math.min(100, Math.max(0, Math.round(v[0])));
                    acc[key][1] += v[1];
                }
                return acc;
            },
            new Array(101).fill(null).map(function(d, i) {
                return [i, 0];
            }));
    }

    /**
     * Container for GcDistributionChart
     */
    class GcDistributionChart extends GenericChart {
        /**
         * Constructor for GcDistributionChart; provide accession OR this.data to generate chart.
         * @param {string} containerId id (without #) of container
         * @param {object} dataOptions to configure chart data source
         * @param {object} chartOptions to configure highcharts chart options
         * (this.data or fetch parameters)
         */
        constructor(containerId, dataOptions, chartOptions) {
            super(containerId, dataOptions);
            if (typeof chartOptions === 'undefined') {
                chartOptions = {};
            }
            this.loaded = $.Deferred();
            this.dataReady.done(() => {
                try {
                    let urlToFile = util.getModelUrl();

                    const options = {
                        chart: {
                            style: {
                                fontFamily: 'Helvetica'
                            },
                            zoomType: 'x'
                        },
                        title: {
                            text: 'Reads GC distribution',
                            style: {
                                fontSize: 16,
                                fontWeight: 'bold'
                            }
                        },
                        subtitle: {
                            text: ( (typeof chartOptions !== 'undefined' &&
                                chartOptions['isFromSubset'])
                                ? 'A subset of the sequences was used to generate this chart. - '
                                : '') + 'Click and drag in the plot area to zoom in'
                        },
                        yAxis: {
                            title: {text: 'Number of reads'}
                        },
                        xAxis: {
                            min: 0,
                            max: 100,

                            plotBands: (this.data === null) ? [] : [
                                { // visualize the standard deviation
                                    from: this.data['average_gc_content'] -
                                    this.data['standard_deviation_gc_content'],
                                    to: this.data['average_gc_content'] +
                                    this.data['standard_deviation_gc_content'],
                                    color: 'rgba(128, 128, 128, .2)',
                                    borderColor: '#000000',
                                    label: {
                                        text: 'Standard Deviation<br/>\u00B1' +
                                        (this.data['standard_deviation_gc_content'].toFixed(2)),
                                        style: {
                                            color: '#666666',
                                            fontSize: '0.8em'
                                        }
                                    }

                                }]
                        },
                        series: [
                            {
                                name: 'Reads',
                                data: this.data['series'],
                                color: (chartOptions['isFromSubset']) ? '#8dc7c7' : '#058dc7'
                            }],
                        legend: {enabled: false},
                        credits: false,
                        navigation: {
                            buttonOptions: {
                                height: 32,
                                width: 32,
                                symbolX: 16,
                                symbolY: 16,
                                y: -10
                            }
                        },
                        exporting: util.getExportingStructure(urlToFile)
                    };
                    this.chart = Highcharts.chart(containerId, options);
                    this.loaded.resolve();
                } catch (exception) {
                    console.error(exception);
                    this.loaded.reject();
                }
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch this.data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const summary = new this.api.QcChartData(
                {id: params['accession'], type: 'summary'});
            const gcDistribution = new this.api.QcChartData(
                {id: params['accession'], type: 'gc-distribution'});

            return $.when(summary.fetch({dataType: 'text'}),
                gcDistribution.fetch({dataType: 'text'})
            ).then((...args) => {
                if (args[0][0][0] === '\n' || args[1][0][0] === '\n') {
                    return Promise.reject();
                }
                const seqLengthData = util.tsv2dict(args[0][0]);
                const gcDistData = transformSeries(args[1][0]);
                this.data = seqLengthData;
                this.data['series'] = gcDistData;
            });

        }
    }

    return GcDistributionChart;
});

},{}],6:[function(require,module,exports){
define([
    './genericChart', '../util', 'highcharts', 'highcharts/modules/exporting'
], function(GenericChart, util, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Container for GoTermPieChart
     */
    class GoTermBarChart extends GenericChart {
        /**
         * Constructor for GcDistributionChart; provide accession OR this.data to generate chart.
         * @param {string} containerId id (without #) of container
         * @param {object} dataOptions to configure chart data source
         * @param {object} chartOptions to configure chart
         * (this.data or fetch parameters)
         */
        constructor(containerId, dataOptions, chartOptions) {
            super(containerId, dataOptions);
            this.loaded = $.Deferred();
            const validLineages = [
                'biological_process',
                'molecular_function',
                'cellular_component'];
            if (validLineages.indexOf(
                    dataOptions['lineage']) === -1) {
                console.error('Go Term chart lineage is not valid, should be one of ' +
                    validLineages);
                return;
            }
            this.dataReady.done(() => {
                let series = [];
                let categories = [];
                let total = 0;
                this.data.forEach(function(d) {
                    d = d.attributes;
                    categories.push(d.description);
                    series.push(d.count);
                    total += d.count;
                });

                let options = {
                    chart: {
                        type: 'bar',
                        height: 800,
                        zoomType: 'xy',
                        renderTo: 'container'
                    },
                    title: {
                        text: chartOptions['title']
                    },
                    subtitle: {
                        text: 'Total: ' + total +
                        ' annotations - Drag to zoom in/out'
                    },
                    yAxis: {
                        min: 0,
                        title: {
                            text: 'Annotations'
                        }
                    },
                    xAxis: {
                        categories: categories
                    },
                    plotOptions: {
                        series: {
                            stacking: 'normal'
                        },
                        bar: {
                            allowPointSelect: true,
                            cursor: 'pointer',
                            colors: util.TAXONOMY_COLOURS
                        }
                    },
                    credits: {
                        enabled: false
                    },
                    legend: {
                        enabled: false
                    },
                    tooltip: {
                        pointFormat: '<b>{point.y}</b> {series.name}'
                    },
                    series: [
                        {
                            name: 'annotations',
                            data: series,
                            color: chartOptions['color']
                        }]
                };
                this.chart = Highcharts.chart(containerId, options);
            }).done(() => {
                this.loaded.resolve();
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch this.data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const seqLength = new this.api.GoSlim(
                {id: params['accession']});

            return $.when(seqLength.fetch()).done(() => {
                this.data = seqLength.attributes.data.filter(function(d) {
                    return d.attributes.lineage === params['lineage'];
                });
            });
        }
    }

    return GoTermBarChart;
});

},{}],7:[function(require,module,exports){
define([
    './genericChart', 'underscore', '../util', 'highcharts', 'highcharts/modules/exporting'
], function(GenericChart, _, util, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Convert data from string to 2d array
     * @param {string} rawdata
     * @return {[[number, number]]}
     */
    function transformData(rawdata) {
        rawdata = rawdata.map(function(d) {
            const attr = d.attributes;
            return {name: attr['description'], y: attr['count']};
        });
        rawdata = _.sortBy(rawdata, function(d) {
            return d.y;
        }).reverse();
        rawdata[10] = rawdata.slice(10).reduce(function(others, d) {
            others.y += d.y;
            return others;
        }, {name: 'Others', y: 0});
        return rawdata.slice(0, 11);
    }

    /**
     * Container for GoTermPieChart
     */
    class GoTermPieChart extends GenericChart {
        /**
         * Constructor for GcDistributionChart; provide accession OR this.data to generate chart.
         * @param {string} containerId id (without #) of container
         * @param {object} dataOptions to configure chart data source
         * @param {object} chartOptions to configure chart
         * (this.data or fetch parameters)
         */
        constructor(containerId, dataOptions, chartOptions) {
            super(containerId, dataOptions);
            this.loaded = $.Deferred();
            const validLineages = [
                'biological_process',
                'molecular_function',
                'cellular_component'];
            if (validLineages.indexOf(
                    dataOptions['lineage']) === -1) {
                console.error('Go Term chart lineage is not valid, should be one of ' +
                    validLineages);
                return;
            }
            this.dataReady.done(() => {
                const categories = [];
                this.data = transformData(this.data);
                let total = 0;
                this.data.forEach(function(e) {
                    categories.push(e.name);
                    total += e.y;
                });
                let options = {
                    chart: {
                        plotBackgroundColor: null,
                        plotBorderWidth: null,
                        plotShadow: false,
                        type: 'pie'
                    },
                    title: {
                        text: typeof chartOptions !== 'undefined' ? chartOptions['title'] : ''
                    },
                    subtitle: {
                        text: 'Total: ' + total + ' annotations'
                    },
                    tooltip: {
                        pointFormat: '<b>{point.y}</b> {series.name} ({point.percentage:.2f}%)'
                    },
                    plotOptions: {
                        pie: {
                            allowPointSelect: true,
                            cursor: 'pointer',
                            dataLabels: {
                                enabled: false
                            },
                            showInLegend: true,
                            colors: util.TAXONOMY_COLOURS
                        }
                    },
                    credits: {
                        enabled: false
                    },
                    series: [
                        {
                            name: 'annotations',
                            colorByPoint: true,
                            data: this.data
                        }],
                    legend: {
                        align: 'right',
                        verticalAlign: 'middle',
                        layout: 'vertical',
                        labelFormatter() {
                            if (this.name.length > 15) {
                                return this.name.slice(0, 15) + '...';
                            } else {
                                return this.name;
                            }
                        }
                    }
                };
                this.chart = Highcharts.chart(containerId, options);
            }).done(() => {
                this.loaded.resolve();
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch this.data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const seqLength = new this.api.GoSlim(
                {id: params['accession']});

            return $.when(seqLength.fetch()).done(() => {
                this.data = seqLength.attributes.data.filter(function(d) {
                    return d.attributes.lineage === params['lineage'];
                });
            });
        }
    }

    return GoTermPieChart;
});

},{}],8:[function(require,module,exports){
define([
    '../util', './genericChart', 'highcharts', 'highcharts/modules/exporting'
], function(util, GenericChart, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Generic taxonomy pie chart class, configurable to
     */
    class TaxonomyPie extends GenericChart {
        /**
         * Instantiate chart
         * @param {string} containerId chart container element
         * @param {[*]} dataOptions
         */
        constructor(containerId, dataOptions) {
            super(containerId, dataOptions);
            this.groupingDepth = dataOptions['groupingDepth'] || 0;
            this.loaded = $.Deferred();

            this.dataReady.done(() => {
                let totalCount = util.sumProp(this.data, 'y');

                let options = {
                    chart: {
                        plotBackgroundColor: null,
                        plotBorderWidth: null,
                        plotShadow: false,
                        type: 'pie'
                    },
                    title: {
                        text: 'InterPro match summary'
                    },
                    subtitle: {
                        text: 'Total: ' + totalCount + ' InterPro matches'
                    },
                    tooltip: {
                        pointFormat: '<b>{point.y}</b> {series.name} ({point.percentage:.2f}%)'
                    },
                    plotOptions: {
                        pie: {
                            allowPointSelect: true,
                            cursor: 'pointer',
                            dataLabels: {
                                enabled: false
                            },
                            colors: util.duplicateLastColor(util.TAXONOMY_COLOURS, this.data)
                        }
                    },
                    credits: {
                        enabled: false
                    },
                    series: [
                        {
                            name: 'pCDS matched',
                            colorByPoint: true,
                            data: this.data
                        }]
                };
                this.chart = Highcharts.chart(containerId, options);
            }).done(() => {
                this.loaded.resolve();
            }).fail(() => {
                this.loaded.reject();
            });
        }

        /**
         * Retrieve data from MGnify API
         * @param {{accession: string, type: string}} params
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const model = new this.api.InterproIden({id: params['accession']});
            return model.fetch().then((data) => {
                this.raw_data = data;
                data = data.map(function(d) {
                    const attr = d.attributes;
                    return {
                        name: attr['description'],
                        y: attr['count']
                    };
                });
                let sumOthers = util.sumProp(data.slice(10), 'y');
                const others = {
                    name: 'Other',
                    y: sumOthers
                };
                this.data = data.slice(0, 10);
                this.data.push(others);
            });
        }
    }

    return TaxonomyPie;
});

},{}],9:[function(require,module,exports){
define([
    '../util', './genericChart', 'highcharts', 'highcharts/modules/exporting'
], function(util, GenericChart, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Container for nucleotide histogram chart
     */
    class NucleotideHist extends GenericChart {
        /**
         *
         * @param {string} containerId for HTML element into which chart will be inserted
         * @param {object} dataOptions parameters to fetch or provide chart data
         * @param {object} chartOptions parameters to customise highcharts chart options
         */
        constructor(containerId, dataOptions, chartOptions) {
            super(containerId, dataOptions);
            this.loaded = $.Deferred();

            this.dataReady.done(() => {
                console.debug('Drawing nucleotide chart');
                let data = {'pos': [], 'A': [], 'G': [], 'T': [], 'C': [], 'N': []};
                let colors = {
                    'A': 'rgb(16, 150, 24)',
                    'G': 'rgb(255, 153, 0)',
                    'C': 'rgb(51, 102, 204)',
                    'T': 'rgb(220, 57, 18)',
                    'N': 'rgb(138, 65, 23)'
                };
                let headers = null;
                this.data.split('\n').forEach(function(line) {
                    if (headers === null) {
                        headers = line.split('\t');
                    } else {
                        line.split('\t').forEach(function(v, i) {
                            data[headers[i]].push(v * 1);
                        });
                    }
                });
                let urlToFile = util.getModelUrl();

                const options = {
                    chart: {
                        renderTo: containerId,
                        type: 'area',
                        style: {
                            fontFamily: 'Helvetica'
                        }
                    },
                    title: {
                        text: 'Nucleotide position histogram',
                        style: {
                            fontSize: 16,
                            fontWeight: 'bold'
                        }
                    },
                    subtitle: {
                        text: (typeof chartOptions !== 'undefined' &&
                            chartOptions['isFromSubset'])
                            ? 'A subset of the sequences was used to generate this chart'
                            : undefined
                    },
                    xAxis: {
                        categories: data['pos'],
                        tickmarkPlacement: 'on',
                        title: {enabled: false}
                    },
                    yAxis: {
                        min: 0,
                        max: 100,
                        title: {enabled: false}
                    },
                    plotOptions: {
                        area: {
                            stacking: 'normal',
                            lineColor: '#666666',
                            lineWidth: 1,
                            marker: {
                                lineWidth: 1,
                                lineColor: '#666666'
                            }
                        }
                    },
                    tooltip: {shared: true},
                    series: ['A', 'T', 'C', 'G', 'N'].map(function(d) {
                        return {
                            name: d,
                            data: data[d],
                            color: colors[d]
                        };
                    }),
                    credits: false,
                    navigation: {
                        buttonOptions: {
                            height: 32,
                            width: 32,
                            symbolX: 16,
                            symbolY: 16,
                            y: -10
                        }
                    },
                    exporting: util.getExportingStructure(urlToFile)
                };
                this.chart = new Highcharts.Chart(options);
            }).done(() => {
                this.loaded.resolve();
            }).fail(() => {
                this.loaded.reject();
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            this.model = new this.api.QcChartData(
                {id: params['accession'], type: 'nucleotide-distribution'});
            const fetch = this.model.fetch({dataType: 'text'}).then((data) => {
                if (data[0] === '\n') {
                    return Promise.reject();
                } else {
                    this.data = data;
                }
            });
            return fetch;
        }
    }

    return NucleotideHist;
});

},{}],10:[function(require,module,exports){
define([
    './genericChart', 'highcharts', 'highcharts/modules/exporting'
], function(GenericChart, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Container for GcDistributionChart
     */
    class QCChart extends GenericChart {
        /**
         * Constructor for GcDistributionChart; provide accession OR data to generate chart.
         * @param {string} containerId id (without #) of container
         * @param {object} options to configure chart data source (data or fetch parameters)
         */
        constructor(containerId, options) {
            super(containerId, options);
            this.loaded = $.Deferred();
            this.dataReady.done(() => {
                console.debug('Drawing QC chart');

                let remaining = [0, 0, 0, 0, 0];
                let filtered = [0, 0, 0, 0, 0];
                let subsampled = [0, 0, 0, 0, 0];

                subsampled[4] = parseInt(this.data['sequence_count']);
                remaining[0] = parseInt(this.data['Submitted nucleotide sequences']);
                remaining[1] = parseInt(
                    this.data['Nucleotide sequences after format-specific filtering']);
                remaining[2] = parseInt(this.data['Nucleotide sequences after length filtering']);
                remaining[3] = parseInt(
                    this.data['Nucleotide sequences after undetermined bases filtering']);
                filtered[2] = remaining[1] - remaining[2];
                filtered[1] = remaining[0] - remaining[1];
                filtered[4] = remaining[3] - remaining[4] - subsampled[4];

                let chartOptions = {
                    chart: {
                        type: 'bar'
                    },
                    title: {
                        text: 'Number of sequence reads per QC step'
                    },
                    yAxis: {
                        min: 0,
                        title: {
                            text: 'Count'
                        }
                    },
                    xAxis: {
                        categories: [
                            'Initial reads',
                            'Trimming',
                            'Length filtering',
                            'Ambiguous base filtering',
                            'Reads subsampled for QC analysis']
                    },
                    plotOptions: {
                        series: {
                            stacking: 'normal'
                        }
                    },
                    credits: {
                        enabled: false
                    },
                    series: [
                        {
                            name: 'Reads filtered out',
                            data: filtered,
                            color: '#CCCCD3'
                        }, {
                            name: 'Reads remaining',
                            data: remaining,
                            color: '#058DC7'
                        }, {
                            name: 'Reads after sampling',
                            data: subsampled,
                            color: '#8dc7c7'
                        }]
                };
                this.chart = Highcharts.chart(containerId, chartOptions);
            }).done(() => {
                this.loaded.resolve();
            }).fail(() => {
                this.loaded.reject();
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const analysis = new this.api.Analysis({id: params['accession']});
            const qcStats = new this.api.QcChartStats({id: params['accession']});

            return $.when(analysis.fetch(), qcStats.fetch({dataType: 'text'})).done(() => {
                this.data = analysis['attributes']['analysis_summary'];
                this.data['sequence_count'] = qcStats['attributes']['sequence_count'];
            });
        }
    }

    return QCChart;
});

},{}],11:[function(require,module,exports){
define([
    './genericChart', '../util', 'highcharts', 'highcharts/modules/exporting'
], function(GenericChart, util, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Convert data from string to 2d array and parse values to float
     * @param {string} rawdata
     * @return {[[number, number]]}
     */
    function transformSeries(rawdata) {
        return rawdata.split('\n').filter(function(line) {
            return line.trim() !== '';
        }).map(function(line) {
            return line.split('\t').map(function(v) {
                return 1 * v;
            });
        });
    }

    /**
     * Container for GcDistributionChart
     */
    class GcDistributionChart extends GenericChart {
        /**
         * Constructor for GcDistributionChart; provide accession OR this.data to generate chart.
         * @param {string} containerId id (without #) of container
         * @param {object} dataOptions to configure chart data source
         * @param {object} chartOptions to configure highcharts chart options
         * (this.data or fetch parameters)
         */
        constructor(containerId, dataOptions, chartOptions) {
            super(containerId, dataOptions);
            if (typeof chartOptions === 'undefined') {
                chartOptions = {};
            }
            this.loaded = $.Deferred();
            this.dataReady.done(() => {
                console.debug('Drawing GC Distribution chart');

                let urlToFile = util.getModelUrl();
                try {
                    // TODO fix once API no longer returns HTML error pages
                    if (!this.data.hasOwnProperty('standard_deviation_length')) {
                        this.loaded.reject();
                        return;
                    }
                    let lengthMax = Math.max.apply(null, this.data['series'].map(function(e) {
                        if (e) {
                            return e[0];
                        }
                    }));
                    const options = {
                        chart: {
                            marginLeft: 78,
                            style: {
                                fontFamily: 'Helvetica'
                            },
                            zoomType: 'x'
                        },
                        title: {
                            text: 'Reads length histogram',
                            style: {
                                fontSize: 16,
                                fontWeight: 'bold'
                            }
                        },
                        subtitle: {
                            text: ((chartOptions['isFromSubset'])
                                ? 'A subset of the sequences was used to generate this chart -'
                                : '') + 'Click and drag in the plot area to zoom in'
                        },
                        yAxis: {
                            title: {text: 'Number of reads'}
                        },
                        xAxis: {
                            min: 0,
                            max: 100 * (Math.floor(lengthMax / 100) + 1),
                            plotBands: (this.data === null) ? [] : [
                                { // visualize the standard deviation
                                    from: this.data['average_length'] -
                                    this.data['standard_deviation_length'],
                                    to: this.data['average_length'] +
                                    this.data['standard_deviation_length'],
                                    color: 'rgba(128, 128, 128, .2)',
                                    label: {
                                        text: 'Standard Deviation<br/>\u00B1' +
                                        (this.data['standard_deviation_length'].toFixed(2)),
                                        style: {
                                            color: '#666666',
                                            fontSize: '0.8em'
                                        }
                                    }
                                }]
                        },
                        series: [
                            {
                                name: 'Reads',
                                data: this.data['series'],
                                color: (chartOptions['isFromSubset']) ? '#8dc7c7' : '#058dc7'
                            }
                        ],
                        legend: {enabled: false},
                        credits: false,
                        navigation: {
                            buttonOptions: {
                                height: 32,
                                width: 32,
                                symbolX: 16,
                                symbolY: 16,
                                y: -10
                            }
                        },
                        exporting: util.getExportingStructure(urlToFile)
                    };
                    this.chart = Highcharts.chart(containerId, options);
                } catch (exception) {
                    console.error(exception);
                    this.loaded.reject();
                }
            }).done(() => {
                this.loaded.resolve();
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch this.data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const summary = new this.api.QcChartData(
                {id: params['accession'], type: 'summary'});
            this.model = new this.api.QcChartData(
                {id: params['accession'], type: 'seq-length'});
            return $.when(summary.fetch({dataType: 'text'}),
                this.model.fetch({dataType: 'text'})
            ).then((...args) => {
                if (args[0][0][0] === '\n' || args[1][0][0] === '\n') {
                    return Promise.reject();
                }
                const summaryData = util.tsv2dict(args[0][0]);
                const seqLenData = transformSeries(args[1][0]);
                this.data = summaryData;
                this.data['series'] = seqLenData;
            });
        }
    }

    return GcDistributionChart;
});

},{}],12:[function(require,module,exports){
define([
    './genericChart', 'highcharts', 'highcharts/modules/exporting'
], function(GenericChart, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Container for GcDistributionChart
     */
    class SeqFeatSumChart extends GenericChart {
        /**
         * Constructor for GcDistributionChart; provide accession OR data to generate chart.
         * @param {string} containerId id (without #) of container
         * @param {object} options to configure chart data source (data or fetch parameters)
         */
        constructor(containerId, options) {
            super(containerId, options);
            this.loaded = $.Deferred();
            this.dataReady.done(() => {
                console.debug('Drawing seq feat sum chart');

                const seqData = this.data['analysis_summary'];
                const pipelineVersion = this.data['pipeline_version'];

                const secondLabel = parseFloat(pipelineVersion) >= 3.0 ? 'Reads with predicted rRNA'
                    : 'Reads with predicted RNA';
                const categories = [
                    'Reads with predicted CDS',
                    secondLabel,
                    'Reads with InterProScan match',
                    'Predicted CDS',
                    'Predicted CDS with InterProScan match'
                ];

                let series = [
                    seqData['Nucleotide sequences with predicted CDS'],
                    seqData['Nucleotide sequences with predicted RNA'],
                    seqData['Nucleotide sequences with InterProScan match'],
                    seqData['Predicted CDS'],
                    seqData['Predicted CDS with InterProScan match']
                ].map(function(e) {
                    return parseInt(e);
                });
                let options = {
                    chart: {
                        type: 'bar'
                    },
                    title: {
                        text: 'Sequence feature summary'
                    },
                    yAxis: {
                        type: 'logarithmic',
                        title: {
                            text: 'Count (note the logarithmic scale)'
                        }
                    },
                    xAxis: {
                        categories: categories
                    },
                    plotOptions: {
                        series: {
                            stacking: 'normal'
                        }
                    },
                    credits: {
                        enabled: false
                    },
                    legend: {
                        enabled: false
                    },
                    tooltip: {
                        pointFormat: '<b>{point.y}</b>'
                    },
                    series: [
                        {
                            data: series,
                            color: '#058dc7'
                        }]
                };
                this.chart = Highcharts.chart(containerId, options);
            }).done(() => {
                this.loaded.resolve();
            }).fail(() => {
                this.loaded.reject();
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const analysis = new this.api.Analysis({id: params['accession']});
            return analysis.fetch().done(() => {
                this.data = analysis['attributes'];
            });
        }
    }

    return SeqFeatSumChart;
});

},{}],13:[function(require,module,exports){
define([
    './genericChart', '../util', 'highcharts', 'highcharts/modules/exporting'
], function(GenericChart, util, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Container for GcDistributionChart
     */
    class GcContentChart extends GenericChart {
        /**
         * Constructor for GcDistributionChart; provide accession OR this.data to generate chart.
         * @param {string} containerId id (without #) of container
         * @param {object} options to configure chart this.data source
         * (this.data or fetch parameters)
         */
        constructor(containerId, options) {
            super(containerId, options);
            this.loaded = $.Deferred();
            this.dataReady.done(() => {
                console.debug('Drawing seq length chart');

                const options = {
                    chart: {
                        type: 'bar',
                        marginTop: 0, // Keep all charts left aligned
                        height: 120
                    },
                    title: false,
                    xAxis: {
                        categories: ['Minimum', 'Average', 'Maximum'],
                        title: {enabled: false},
                        lineColor: '#595959',
                        tickColor: ''
                    },
                    yAxis: {
                        min: 0,
                        max: 100 * (Math.floor(this.data['length_max'] / 100) + 1),
                        title: {text: 'Sequence length (bp)'},
                        plotBands: [
                            { // visualize the standard deviation
                                from: this.data['average_length'] -
                                this.data['standard_deviation_length'],
                                to: this.data['average_length'] +
                                this.data['standard_deviation_length'],
                                color: 'rgba(128, 128, 128, .2)'
                            }]
                    },
                    plotOptions: {
                        series: {
                            grouping: false,
                            shadow: false,
                            borderWidth: 0
                        }
                    },
                    series: [
                        {
                            name: 'Length',
                            data: [
                                {
                                    y: this.data['length_min'],
                                    x: 0,
                                    color: 'rgb(114, 191, 63)'
                                },
                                {
                                    y: this.data['average_length'],
                                    x: 1,
                                    color: 'rgb(63, 114, 191)'
                                },
                                {
                                    y: this.data['length_max'],
                                    x: 2,
                                    color: 'rgb(114, 63, 191)'
                                }
                            ],
                            pointPadding: -0.2,
                            tooltip: {
                                pointFormatter: function() {
                                    return '<span style="color:' + this.color +
                                        '">\u25CF</span> ' +
                                        this.category + ': <b>' + (this.y).toFixed(2) +
                                        '</b><br/>';
                                }
                            }
                        }
                    ],
                    legend: {enabled: false},
                    credits: false,
                    navigation: {
                        buttonOptions: {
                            height: 32,
                            width: 32,
                            symbolX: 16,
                            symbolY: 16,
                            y: -10
                        }
                    },
                    exporting: {enabled: false}
                };
                this.chart = Highcharts.chart(containerId, options);
                this.loaded.resolve();
            });
        }

        /**
         * Fetch relevant models from MGnify API
         * @param {object} params required to fetch this.data
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const seqLength = new this.api.QcChartData(
                {id: params['accession'], type: 'summary'});

            return $.when(seqLength.fetch({dataType: 'text'})).then((data) => {
                if (data[0]==='\n'){
                    return Promise.reject();
                }
                this.data = util.tsv2dict(data);
            });
        }
    }

    return GcContentChart;
});

},{}],14:[function(require,module,exports){
define([
    '../util', './genericChart', 'highcharts', 'highcharts/modules/exporting'
], function(util, GenericChart, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Generic taxonomy pie chart class, configurable to
     */
    class TaxonomyColumn extends GenericChart {
        /**
         * Instantiate chart
         * @param {string} containerId chart container element
         * @param {object} dataOptions parameters to fetch or provide chart data
         * @param {object} chartOptions parameters to customise highcharts chart options
         */
        constructor(containerId, dataOptions, chartOptions) {
            super(containerId, dataOptions);
            this.groupingDepth = dataOptions['groupingDepth'] || 0;
            this.loaded = $.Deferred();

            this.dataReady.done(() => {
                console.debug('Drawing taxonomy column chart');

                const categories = [];
                this.clusteredData = util.groupTaxonomyData(this.data, this.groupingDepth);
                this.clusteredData.forEach(function(e) {
                    categories.push(e.name);
                });
                let options = {
                    chart: {
                        plotBackgroundColor: null,
                        plotBorderWidth: null,
                        plotShadow: false,
                        type: 'column'
                    },
                    title: {
                        text: typeof chartOptions !== 'undefined' ? chartOptions['title'] : ''
                    },
                    credits: {
                        enabled: false
                    },
                    series: [
                        {
                            colorByPoint: true,
                            data: this.clusteredData,
                            colors: util.TAXONOMY_COLOURS
                        }],
                    xAxis: {
                        categories: categories,
                        title: {
                            text: null
                        }
                    },
                    yAxis: {
                        min: 0,
                        title: {
                            text: 'Unique OTUs',
                            align: 'high'
                        },
                        labels: {
                            overflow: 'justify'
                        }
                    },
                    tooltip: {
                        formatter() {
                            let perc = 100 * this.y / util.sumData(this.series.data);
                            return this.x + '<br/>' + '<b>' + this.y +
                                '</b> ' + chartOptions['seriesName'] + ' (' + (perc).toFixed(2) +
                                '%)';
                        }
                    },
                    legend: {
                        enabled: false
                    }
                };
                if (typeof chartOptions !== 'undefined') {
                    if (typeof chartOptions['subtitle'] === 'undefined' ||
                        chartOptions['subtitle']) {
                        options.subtitle = {
                            text: 'Total: ' + util.sumData(this.data) + ' ' +
                            chartOptions['seriesName']
                        };
                    }
                }
                this.chart = Highcharts.chart(containerId, options);
            }).done(() => {
                this.loaded.resolve();
            }).fail(() => {
                this.loaded.reject();
            });
        }

        /**
         * Retrieve data from MGnify API
         * @param {{accession: string, type: string}} params
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const model = new this.api.Taxonomy({id: params['accession'], type: params['type']});
            return model.fetch().then((data) => {
                this.data = data;
            });
        }
    }

    return TaxonomyColumn;
});

},{}],15:[function(require,module,exports){
define([
    '../util', './genericChart', 'highcharts', 'highcharts/modules/exporting'
], function(util, GenericChart, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Reformat data into multiple series
     * @param {object} data
     * @return {Array} of data
     */
    function transformData(data) {
        let i = 0;
        const maxColorIndex = util.TAXONOMY_COLOURS.length - 1;
        return data.map(function(e) {
            return {
                name: e.name,
                data: [e.y],
                color: util.TAXONOMY_COLOURS[Math.min(i++, maxColorIndex)]
            };
        });
    }

    /**
     * Generic taxonomy pie chart class, configurable to
     */
    class TaxonomyColumnStacked extends GenericChart {
        /**
         * Instantiate chart
         * @param {string} containerId chart container element
         * @param {[*]} dataOptions
         * @param {[*]} chartOptions
         */
        constructor(containerId, dataOptions, chartOptions) {
            super(containerId, dataOptions);
            this.loaded = $.Deferred();
            if (!chartOptions) {
                chartOptions = {};
            }
            if (!chartOptions.hasOwnProperty('seriesName')) {
                chartOptions['seriesName'] = 'reads';
            }

            this.dataReady.done(() => {
                console.debug('Drawing taxonomy stacked column chart');

                const categories = [];
                this.clusteredData = util.groupTaxonomyData(this.data, 2);
                this.data = transformData(this.clusteredData);
                this.data.forEach(function(e) {
                    categories.push(e.name);
                });
                const sumData = util.sumData(this.clusteredData);
                let titleText;
                if (typeof chartOptions !== 'undefined' && chartOptions.hasOwnProperty('title')) {
                    titleText = chartOptions['title'];
                } else {
                    titleText = '';
                }
                let options = {
                    chart: {
                        plotBackgroundColor: null,
                        plotBorderWidth: null,
                        plotShadow: false,
                        type: 'column'
                    },
                    title: {
                        text: titleText
                    },
                    subtitle: {
                        text: 'Total: ' + sumData + ' ' +
                        chartOptions['seriesName']
                    },
                    credits: {
                        enabled: false
                    },
                    tooltip: {
                        formatter() {
                            let perc = 100 * this.y / sumData;
                            return this.series.name + '<br/>' + '<b>' + this.y +
                                '</b> ' + chartOptions['seriesName'] + ' (' + (perc).toFixed(2) +
                                '%)';
                        }
                    },
                    plotOptions: {
                        series: {
                            stacking: 'percent',
                            dataLabels: {
                                enabled: true
                            }
                        }
                    },
                    yAxis: {
                        min: 0,
                        max: 100
                    },
                    xAxis: {
                        title: {
                            text: null,
                            enabled: false
                        },
                        labels: {
                            enabled: false
                        }
                    },
                    legend: {
                        enabled: false
                    },
                    series: this.data
                };
                this.chart = Highcharts.chart(containerId, options);
            }).done(() => {
                this.loaded.resolve();
            }).fail(() => {
                this.loaded.reject();
            });
        }

        /**
         * Retrieve data from MGnify API
         * @param {{accession: string, type: string}} params
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const model = new this.api.Taxonomy({id: params['accession'], type: params['type']});
            return model.fetch().then((data) => {
                this.data = data;
            });
        }
    }

    return TaxonomyColumnStacked;
});

},{}],16:[function(require,module,exports){
/**
 * Extend reference array of colours such that last colour is duplicated for
 * additional data point
 * @param {[string]} colours
 * @param {[*]} data
 * @return {[string]} of colours with length === length of data
 */
function duplicateLastColor(colours, data) {
    let newColours = [];
    let i = 0;
    while (i < data.length) {
        newColours.push(colours[Math.min(i, colours.length - 1)]);
        i++;
    }
    return newColours;
}

define([
    '../util', './genericChart', 'highcharts', 'highcharts/modules/exporting'
], function(util, GenericChart, Highcharts, exporting) {
    exporting(Highcharts);

    /**
     * Generic taxonomy pie chart class, configurable to
     */
    class TaxonomyPie extends GenericChart {
        /**
         * Instantiate chart
         * @param {string} containerId chart container element
         * @param {[*]} dataOptions
         * @param {[*]} chartOptions
         */
        constructor(containerId, dataOptions, chartOptions) {
            super(containerId, dataOptions);
            this.groupingDepth = dataOptions['groupingDepth'] || 0;
            this.loaded = $.Deferred();

            this.dataReady.done(() => {
                console.debug('Drawing taxonomyPie chart');

                const categories = [];
                this.clusteredData = util.groupTaxonomyData(this.data, this.groupingDepth);
                this.data = util.groupAfterN(this.clusteredData, 10);
                this.data.forEach(function(e) {
                    categories.push(e.name);
                });
                let options = {
                    chart: {
                        plotBackgroundColor: null,
                        plotBorderWidth: null,
                        plotShadow: false,
                        type: 'pie'
                    },
                    title: {
                        text: typeof chartOptions !== 'undefined' ? chartOptions['title'] : ''
                    },
                    tooltip: {
                        pointFormat: '<b>{point.y}</b> {series.name} ({point.percentage:.2f}%)'
                    },
                    plotOptions: {
                        pie: {
                            allowPointSelect: true,
                            cursor: 'pointer',
                            dataLabels: {
                                enabled: true,
                                format: '<b>{point.name}</b>: {point.percentage:.2f} %',
                                style: {
                                    color: (Highcharts.theme && Highcharts.theme.contrastTextColor)
                                    || 'black'
                                }
                            },
                            colors: duplicateLastColor(util.TAXONOMY_COLOURS, this.data)
                        }
                    },
                    credits: {
                        enabled: false
                    },
                    series: [
                        {
                            name: typeof chartOptions !== 'undefined'
                                ? chartOptions['seriesName']
                                : '',
                            colorByPoint: true,
                            data: this.data
                        }]
                };
                // if (chartOptions) {
                //     options = $.extend(true, options, chartOptions);
                // }
                if (typeof chartOptions !== 'undefined') {
                    if (typeof chartOptions['subtitle'] === 'undefined' ||
                        chartOptions['subtitle']) {
                        options.subtitle = {
                            text: 'Total: ' + util.sumData(this.data) + ' ' +
                            chartOptions['seriesName']
                        };
                    }
                    if (chartOptions['legend']) {
                        options.legend = {
                            title: {
                                text: 'Click to hide'
                            },
                            align: 'right',
                            verticalAlign: 'middle',
                            layout: 'vertical',
                            labelFormatter() {
                                if (this.name.length > 15) {
                                    return this.name.slice(0, 15) + '...';
                                } else {
                                    return this.name;
                                }
                            }
                        };
                        options.plotOptions.pie.showInLegend = true;
                    }
                }
                this.chart = Highcharts.chart(containerId, options);
            }).done(() => {
                this.loaded.resolve();
            }).fail(() => {
                this.loaded.reject();
            });
        }

        /**
         * Retrieve data from MGnify API
         * @param {{accession: string, type: string}} params
         * @return {jQuery.promise}
         */
        fetchModel(params) {
            const model = new this.api.Taxonomy({id: params['accession'], type: params['type']});
            return model.fetch().then((data) => {
                this.data = data;
            });
        }
    }

    return TaxonomyPie;
});

},{}],17:[function(require,module,exports){
const MONTHS = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];

define(['underscore'], function(_) {

    const TAXONOMY_COLOURS = [
        '#058dc7',
        '#82d23d',
        '#e26736',
        '#fbe300',
        '#24cbe5',
        '#c49ecc',
        '#ffc08a',
        '#708090',
        '#6af9c4',
        '#caae74',
        '#cccccc'
    ];

    /**
     * Get sum of property values in array
     * @param {[object]} arr array of objects
     * @param {string} prop property to sum over
     * @return {number} sum of property vlaues in array
     */
    function sumProp(arr, prop){
        let total = 0;
        for (let i = 0, _len = arr.length; i < _len; i++) {
            total += arr[i][prop];
        }
        return total;
    }
    /**
     * Retrieve biome from lineage
     * @param {string} lineage
     * @return {string}
     */
    function lineageToBiome(lineage) {
        return lineage.split(':').splice(-1);
    }

    /**
     * Format datestr for readability
     * @param {string} dateStr
     * @return {string}
     */
    function formatDate(dateStr) {
        let d = new Date(dateStr);
        return d.getDate() + '-' + MONTHS[d.getMonth()] + '-' + d.getFullYear();
    }

    /**
     * Format lineage by removing root and replacing ':' with '>'
     * @param {string} lineage
     * @param {boolean} removeRoot
     * @return {string}
     */
    function formatLineage(lineage, removeRoot) {
        let splitLineage = lineage.split(':');
        if (removeRoot) {
            splitLineage = splitLineage.slice(1);
        }
        return splitLineage.join(' > ');
    }

    /**
     * Simplify a list of biomes by grouping them by biome icon
     * @param {[object]} biomes list of biomes
     * @return {[object]} list of biomes grouped by biome icon
     */
    function simplifyBiomeIcons(biomes) {
        const groupedBiomes = {};
        biomes.forEach(function(b) {
            if (groupedBiomes.hasOwnProperty(b.icon)) {
                groupedBiomes[b.icon].push(b.name);
            } else {
                groupedBiomes[b.icon] = [b.name];
            }
        });
        const icons = [];
        Object.keys(groupedBiomes).forEach(function(biomeIcon) {
            const biomes = groupedBiomes[biomeIcon].sort().join(', ');
            icons.push({name: biomes, icon: biomeIcon});
        });
        return icons;
    }

    /**
     * Retrieve icon and name from biome object
     * @param {object} biomeData
     * @return {{name: string, icon}}
     */
    function getBiomeIconData(biomeData) {
        const name = biomeData.id;
        return {name: formatLineage(name, true), icon: getBiomeIcon(name)};
    }

    const biomeIconMapD2 = {
        'root:engineered': 'engineered_b'
    };
    const biomeIconMapD3 = {
        'root:engineered:wastewater': 'wastewater_b',
        'root:environmental:air': 'air_b',
        'root:host-associated:amphibia': 'amphibian_b',
        'root:host-associated:arthropoda': 'arthropoda_b',
        'root:host-associated:fish': 'fish_b',
        'root:host-associated:human': 'human_host_b',
        'root:host-associated:insecta': 'insect_b',
        'root:host-associated:mammals': 'mammals_b',
        'root:host-associated:mollusca': 'mollusca_b',
        'root:host-associated:plants': 'plant_host_b',
        'root:host-associated:porifera': 'porifera_b'

    };
    const biomeIconMapD4 = {
        'root:environmental:aquatic:freshwater': 'freshwater_b',
        'root:environmental:aquatic:marine': 'marine_b',
        'root:environmental:aquatic:thermal springs': 'hotspring_b',
        'root:environmental:terrestrial:soil': 'soil_b',
        'root:environmental:terrestrial:volcanic': 'vulcano_b',
        'root:host-associated:human:digestive system': 'human_gut_b',
        'root:host-associated:human:skin': 'skin_b'
    };

    const biomeIconMapD5 = {
        'root:environmental:aquatic:freshwater:drinking water': 'drinking_water_b',
        'root:environmental:aquatic:freshwater:groundwater': 'groundwater_b',
        'root:environmental:aquatic:freshwater:ice': 'ice_b',
        'root:environmental:aquatic:freshwater:lake': 'lake_b',
        'root:environmental:aquatic:freshwater:lotic': 'river_b',
        'root:environmental:aquatic:marine:hydrothermal vents': 'hydrothermal_vents_b',
        'root:environmental:terrestrial:soil:wetlands': 'wetlands_b',
        'root:host-associated:human:digestive system:oral': 'mouth_b',
        'root:host-associated:human:respiratory system:pulmonary system': 'lung_b',
        'root:host-associated:mammals:nervous system:brain': 'brain_b'
    };

    const biomeIconMapD6 = {
        'root:environmental:aquatic:freshwater:groundwater:cave water': 'cave_b',
        'root:environmental:aquatic:freshwater:ice:glacier': 'glacier_b',
        'root:environmental:terrestrial:soil:grasslands': 'grassland_b',
        'root:environmental:terrestrial:soil:loam:forest soil': 'forest_b',
        'root:environmental:terrestrial:soil:sand:desert': 'desert_b'
    };

    /**
     * Retrieve biome icon for a lineage
     * @param {string} lineage
     * @return {string} css class for biome
     */
    function getBiomeIcon(lineage) {
        const lineageList = lineage.split(':').map(function(x) {
            return x.toLowerCase();
        });

        const lineageD2 = lineageList.slice(0, 2).join(':');
        const lineageD3 = lineageList.slice(0, 3).join(':');
        const lineageD4 = lineageList.slice(0, 4).join(':');
        const lineageD5 = lineageList.slice(0, 5).join(':');
        const lineageD6 = lineageList.slice(0, 6).join(':');

        return biomeIconMapD6[lineageD6] || biomeIconMapD5[lineageD5] ||
            biomeIconMapD4[lineageD4] ||
            biomeIconMapD3[lineageD3] || biomeIconMapD2[lineageD2] || (function() {
                console.debug('Could not match lineage "' + lineage + '" with any biome icons');
                return 'default_b';
            }());
    }

    /**
     * Cluster data by depth
     * @param {[*]} data
     * @param {number} depth
     * @return {[*]}≈
     */
    function clusterData(data, depth) {
        let clusteredData = {};
        _.each(data, function(d) {
            const attr = d.attributes;
            let lineage = attr.lineage.split(':');
            // Remove empty strings
            let category;
            if (lineage.length < depth) {
                category = lineage[lineage.length - 1];
            } else {
                category = lineage[depth];
            }

            if (depth > 0 &&
                ['', 'Bacteria', 'Eukaryota', 'other_sequences', undefined].indexOf(category) >
                -1) {
                if (lineage[0] === 'Bacteria') {
                    category = 'Unassigned Bacteria';
                } else {
                    category = 'Unassigned';
                }
            }

            let val = attr.count;
            if (clusteredData.hasOwnProperty(category)) {
                clusteredData[category]['v'] += val;
            } else {
                clusteredData[category] = {
                    v: val,
                    l: lineage
                };
            }
        });
        clusteredData = _.map(clusteredData, function(values, k) {
            return {
                name: k,
                y: values.v,
                lineage: values.l
            };
        });
        return clusteredData;
    }

    /**
     * Group taxonomy data by lineage at depth and sort by decreasing value
     * @param {[object]} data
     * @param {int} depth of lineage at which to group data
     * @return {[object]} sorted list of data grouped and summed by lineage
     */
    function groupTaxonomyData(data, depth) {
        return _.sortBy(clusterData(data, depth), function(o) {
            return o.y;
        }).reverse();
    }

    /**
     * Group all data after index n into single category
     * @param {[*]} clusteredData
     * @param {number} n index after which to group data
     * @return {[*]} grouped data
     */
    function groupAfterN(clusteredData, n) {
        if (clusteredData.length > n) {
            const top10 = clusteredData.slice(0, n);
            const others = {
                name: 'Other',
                lineage: [],
                y: 0
            };
            _.each(clusteredData.slice(n, clusteredData.length), function(d) {
                others.y += d.y;
                if (others.lineage.indexOf(d.lineage[0]) === -1) {
                    others.lineage.push(d.lineage[0]);
                }
            });
            others.lineage = others.lineage.join(', ');
            top10.push(others);
            clusteredData = top10;
        }
        return clusteredData;
    }

    /**
     * Sum data by parameter
     * @param {[object]} data
     * @return {number} sum of parameters y in array
     */
    function sumData(data) {
        let sum = 0;
        data.forEach(function(e) {
            sum += e.y;
        });
        return sum;
    }

    /**
     * Generate button menu for chart downloads
     * @param {string} urlToFile
     * @param {string} content
     * @return {object}
     */
    function getExportingStructure(urlToFile, content) {
        return {
            buttons: {
                contextButton: {
                    menuItems: [
                        {
                            text: 'Download data',
                            onclick: function() {
                                if (typeof content === 'undefined') {
                                    window.location = urlToFile;
                                } else {
                                    let element = document.createElement('a');
                                    element.setAttribute('href', 'data:text/plain;charset=utf-8,' +
                                        encodeURIComponent(content));
                                    element.setAttribute('download', urlToFile);

                                    element.style.display = 'none';
                                    document.body.appendChild(element);

                                    element.click();

                                    document.body.removeChild(element);
                                }
                            }
                        }, {
                            separator: true
                        }, {
                            textKey: 'printChart',
                            onclick: function() {
                                this.print();
                            }
                        }, {
                            separator: true
                        }, {
                            textKey: 'downloadPNG',
                            onclick: function() {
                                this.exportChart({
                                    width: 1200,
                                    filename: 'sq_sum_bar_chart'
                                    // externalRunId need to be added to the model -
                                    // NOTE the name is common between QC and Functional
                                });
                            }
                        }, {
                            textKey: 'downloadJPEG',
                            onclick: function() {
                                this.exportChart({
                                    width: 1200,
                                    filename: 'sq_sum_bar_chart',
                                    // externalRunId need to be added to the model -
                                    // NOTE the name is common between QC and Functional
                                    type: 'image/jpeg'
                                });
                            }
                        }, {
                            textKey: 'downloadPDF',
                            onclick: function() {
                                this.exportChart({
                                    filename: 'sq_sum_bar_chart',
                                    // externalRunId need to be added to the model -
                                    // NOTE the name is common between QC and Functional
                                    type: 'application/pdf'
                                });
                            }
                        }, {
                            textKey: 'downloadSVG',
                            onclick: function() {
                                this.exportChart({
                                    filename: 'sq_sum_bar_chart',
                                    // externalRunId need to be added to the model -
                                    // NOTE the name is common between QC and Functional
                                    type: 'image/svg+xml'
                                });
                            }
                        }]
                }
            }
        };
    }

    /**
     * Convert a two-column tab-seperated-value string into dictionary
     * @param {string} str representing tab seperated values
     * @return {object}
     */
    function tsv2dict(str) {
        return str.split('\n').reduce((map, row) => {
            row = row.split('\t');
            if (row[0].length > 0) {
                map[row[0]] = parseFloat(row[1]);
            }
            return map;
        }, {});
    }

    /**
     * Retrieve model url from Backbone model
     * @return {string}
     */
    function getModelUrl() {
        let urlToFile;
        if (typeof this.model !== 'undefined') {
            if (typeof this.model.url === 'function') {
                urlToFile = this.model.url();
            } else {
                urlToFile = this.model.url;
            }
        } else {
            urlToFile = '';
        }
        return urlToFile;
    }

    /**
     * Extend reference array of colours such that last colour is duplicated for
     * additional data point
     * @param {[string]} colours
     * @param {[*]} data
     * @return {[string]} of colours with length === length of data
     */
    function duplicateLastColor(colours, data) {
        let newColours = [];
        let i = 0;
        while (i < data.length) {
            newColours.push(colours[Math.min(i, colours.length - 1)]);
            i++;
        }
        return newColours;
    }

    return {
        TAXONOMY_COLOURS,
        sumProp,
        lineageToBiome,
        formatDate,
        formatLineage,
        simplifyBiomeIcons,
        getBiomeIconData,
        getBiomeIcon,
        groupTaxonomyData,
        groupAfterN,
        sumData,
        getExportingStructure,
        tsv2dict,
        getModelUrl,
        duplicateLastColor
    };
});

},{}],18:[function(require,module,exports){
// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };

},{}]},{},[1]);
